#include "GroupStructure.h"


void OED_individual::makeSourceNodes(DAG &G, const string &name){

	for(int i=1; i<=p.Size();i++)
	{
	  p(i)=MakeVar(&G, name+"_p_"+ToString(i));
	}

	for(int i=1; i<=t.Size();i++)
	{
	t(i)=MakeVar(&G, name+"_t_"+ToString(i));
	}

	A=MakeVar(&G,name+"_A_");

}


void OED_individual::makeDAG(DAG &G){

	for(int i=1; i<=t.Size(); i++){
		
		y(i) = model( t(i), p, A); 
	
	}

}


void OED_individual::initialize(Filter &F,
		const VECTOR<interval> &r_t,
		const VECTOR<interval> &r_p,
		const interval &r_A){
		
		SetConstants(*F.G, F.V);
		F.Write(t,  r_t);
		F.Write(p, r_p);
		F.Write(A, r_A);
		F.SweepForwardIO();
}   

















