class OUTPUT{
public:
OUTPUT(){};
OUTPUT(const string &_DIR, 
							int _Ns, 
							int _Ni, 
							vNODE &p1, 
							NODE &p2, 
							NODE &p3, 
							VECTOR<NODE> &y);

string DIR;

int Ni;
int Ns;
VECTOR<int>	y_num;
VECTOR<int>	p1_num;
int					p2_num;
int					p3_num;

void _gpoint(const string &filename);
void _gimage(const string &filename);
void DataRanges(const string &filename, 
								const VECTOR<interval> &V);
void p1p2p3_Boxes(const string &filename, LIST<VECTOR<interval> > &L);
void p2p3_Boxes(const string &filename, LIST<VECTOR<interval> > &L);

void clean_and_perturbed_data(VECTOR<interval> &ysharp_data, 
															VECTOR<interval> &y_data,
															VECTOR<double> &psharp,
															VECTOR<double> &p1star);

void vec(const string & filename, VECTOR<double> &vec);

void image(int individualNr, 
								LIST<VECTOR<interval> > list_image, 
								const string &filename);

void point(int individualNr, 
								LIST<VECTOR<interval> > list_point, 
								const string &filename);

};


OUTPUT::OUTPUT(const string &_DIR, 
							int _Ns, 
							int _Ni, 
							vNODE &p1, 
							NODE &p2, 
							NODE &p3, 
							VECTOR<NODE> &y){

DIR = _DIR;
Ns=_Ns;
Ni	=_Ni;

VECTOR<int> _p1_num(p1.Size());
int _p2_num;	
int _p3_num;
VECTOR<int> _y_num(y.Size());

for(int i=1; i<=_p1_num.Size(); i++){

	_p1_num(i)=p1(i).NodePtr()->num;

}

_p2_num=p2.NodePtr()->num;
_p3_num=p3.NodePtr()->num;

for(int i=1; i<=y.Size(); i++){

			_y_num(i) = y(i).NodePtr()->num; 
}

p1_num	=	_p1_num;
p2_num =	_p2_num;
p3_num	=	_p3_num;
y_num	=	_y_num;

}




void OUTPUT::_gpoint(const string &filename){
/////////////////////////////////////
// Save the global gpoint
/////////////////////////////////////

	VECTOR<double> p(gpoint.Size());
	for(int i=1;i<=p.Size(); i++){p(i) = mid(gpoint(i));}
	StoreVECTOR(p,	DIR + filename +".txt");
}	


void OUTPUT::_gimage(const string &filename){
/////////////////////////////////////
// Save the global gimage
/////////////////////////////////////

VECTOR<double> r(Ns);
int n;
for(int j=1; j<=Ni; j++){
	for(int i=1; i<=Ns; i++){
		r(i)=mid(gimage( (i-1)*Ni + j )); 
	}
	StoreVECTOR(r,	DIR + filename +"_ind" + ToString(j)+ ".txt");
}
}


void OUTPUT::DataRanges(const string &filename, 
								const VECTOR<interval> &V){
VECTOR<interval> R(Ns); 
for(int j=1; j<=Ni; j++){
	for(int i=1; i<=Ns; i++){
		//R(i) = V( y( (i-1)*Ni + j ).NodePtr()->num );
		R(i) = V(  y_num( (i-1)*Ni + j ) );
	}
	StoreIntervalVECTOR(R, DIR + "data_" + filename +"_ind" + ToString(j)+ ".txt");
}

}

void OUTPUT::p1p2p3_Boxes(const string &filename, LIST<VECTOR<interval> > &L){

	LIST<VECTOR<interval> > OUTList;
	VECTOR<interval> w(3);
	for(int i=1; i<=p1_num.Size(); i++){
		
		OUTList.Clean();
		L.MoveTop();
		while(!L.eol()){

			w(1) = L.Data()(p1_num(i));
			w(2) = L.Data()(p2_num);
			w(3) = L.Data()(p3_num);
			
			OUTList.push(w);
			L.MoveDown();
		}
		//WriteBoxesInlineFormat(OUTList, DIR +"p1p2p3_" + filename + "_ind" + ToString(i) + ".txt");
		WriteBoxes(OUTList, DIR +"p1p2p3_" + filename + "_ind" + ToString(i) + ".txt");
	}
}

void OUTPUT::p2p3_Boxes(const string &filename, LIST<VECTOR<interval> > &L){
VECTOR<interval> w(2);
LIST<VECTOR<interval> > OUTList;

L.MoveTop();
while(!L.eol()){
	w(1) = L.Data()( p2_num );
	w(2) = L.Data()( p3_num );
	OUTList.push(w);
	L.MoveDown();
}

//MergeAdjacent(OUTList);
//WriteBoxesInlineFormat(OUTList, DIR + "p2p3_" + filename + ".txt");
WriteBoxes(OUTList, DIR + "p2p3_" + filename + ".txt");

}


void OUTPUT::clean_and_perturbed_data(VECTOR<interval> &ysharp_data, 
															VECTOR<interval> &y_data,
															VECTOR<double> &psharp,
															VECTOR<double> &p1star){

//
//convert ysharp_data and y_data to double
//
VECTOR<double> _ysharp_data(Ns), _y_data(Ns);			

for(int j=1; j<=Ni; j++){			
	for(int i=1; i<=Ns; i++){

		_ysharp_data(i) = inf( ysharp_data( (i-1)*Ni + j ) );
		_y_data(i) = inf( y_data( (i-1)*Ni + j ) );
	}
	StoreVECTOR(_ysharp_data, DIR + "ysharp_data_ind"+ToString(j)+".txt");
	StoreVECTOR(_y_data, DIR + "y_data_ind"+ToString(j)+".txt");
	
}

StoreVECTOR(p1star,	DIR + "p1star.txt");
StoreVECTOR(psharp,	DIR + "psharp.txt");

}

void OUTPUT::vec(const string & filename, VECTOR<double> &vec){
StoreVECTOR(vec,	DIR + filename);
  
}


void OUTPUT::image(int individualNr, 
								LIST<VECTOR<interval> > list_image, 
								const string &filename){

VECTOR<double> r(Ns*list_image.Size());
VECTOR<interval> im(Ns);
int n(0);
list_image.MoveTop();
while(!list_image.eol()){
	
	im=list_image.Data();
	for(int i=1; i<=Ns; i++){
		r(i + Ns*n)=mid(  im( (i-1)*Ni + individualNr )  ); 
	}
	n++;
	list_image.MoveDown();
}
StoreVECTOR(r,	DIR + filename +"_ind" + ToString(individualNr)+ ".txt");

}

void OUTPUT::point(int individualNr, 
								LIST<VECTOR<interval> > list_point, 
								const string &filename){

VECTOR<double> r(2*list_point.Size());
VECTOR<interval> p;
int n(0);
list_point.MoveTop();
while(!list_point.eol()){
	
		p = list_point.Data();
		r(1 + 2*n) = mid( p(Ni+1) );
		r(2 + 2*n) = mid( p(Ni+2) );
		n++;
		list_point.MoveDown();
}

StoreVECTOR(r,	DIR + filename +"_ind" + ToString(individualNr)+ ".txt");

}
