
#ifndef __DAG_H__
#define __DAG_H__


#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <float.h>


#include "Structs/interval.h"
#include "Structs/LIST.h"
#include "Structs/VECTOR.h"
#include <map>


class NODE; 

class DAG{

public:
     
public:    LIST<NODE*> *nodelist;
public:
            DAG();
           ~DAG();
	
	   map<interval,NODE*> 	  constants;	           
	   int  Size              ()const;
	   void NodeEnumeration   ();
	   void NumberToPointer   ( VECTOR<NODE*> &V    );
	   
	      
	   void   InsertNode(NODE *n);
	   void   RemoveNode(NODE *n);
	   bool isEquivalent(NODE* &candidate, const string &nodesym, NODE* p1, NODE *p2);
	   bool   isEquivalentTo(const string &nodesymbol, LIST<NODE*> *predList); 
	   NODE*  ConstructNODE(const interval &r);
	   NODE*  ConstructNODE(const string &nodesym, LIST<NODE*> *predList);

	   void    GetNodeList(LIST<NODE*>*& L); 
	   friend ostream & operator<<(ostream & stream, const DAG &n);
	   
	   static bool sEnableRewrite;
	
		
	typedef NODE* (*RewriteFunction)(DAG &G, const string& nodesym, LIST<NODE*> *predList);
	VECTOR<RewriteFunction> RewriteSystem;

	   static bool sEnableReuse;
	   static DAG* sCurrDAG;
};





#endif

























