#ifndef _DAGREWRITE_H_
#define _DAGREWRITE_H_


#include "DAG/DAG.h"
#include "DAG/NODE.h"
#include "DAG/DAGUtilities.h"

#include "Structs/LIST.h"
#include "Structs/interval.h"




class DAGRewrite{

public:


bool stdOutput;
DAGRewrite();
bool isMulPow_xa_Pow_xb 		(NODE *n, NODE *x, NODE *a, NODE *b);

static NODE* Pow_xa_Mul_Pow_xb		(DAG &G, const string &nodesym, LIST<NODE*> *predList);
static NODE* FactorSmallestExp		(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* RightAssoc			(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* Constant			(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* Constant1			(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* Subtraction		(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* Identities			(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* FirstLevelFactorization	(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* SinglePred			(DAG &G, const string& nodesym, LIST<NODE*> *predList);
static NODE* ConstFold			(DAG &G, const string& nodesym, LIST<NODE*> *predList);

static NODE* Simplify			(DAG &G, const string& nodesym, LIST<NODE*> *predList);

static NODE* The_Other_Predecessor	(NODE *p, NODE*c);
static NODE* FindCommon			(LIST<NODE*> &L1, LIST<NODE*> &L2);

static void Info();
}; 




bool isMulPow_xa_Pow_xb (NODE *n, NODE *x, NODE *a, NODE *b);
NODE* Pow_xa_Mul_Pow_xb(DAG &G, const string &nodesym, LIST<NODE*> *predList);
NODE* RewriteFactorSmallestExp(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteRightAssoc(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteConstant(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteConstant1(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteSubtraction(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteIdentities(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* FindCommon(LIST<NODE*> &L1, LIST<NODE*> &L2);
NODE* The_Other_Predecessor(NODE *p, NODE*c);
NODE* Rewrite_FirstLevelFactorization(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteSinglePred(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* RewriteConstFold(DAG &G, const string& nodesym, LIST<NODE*> *predList);
NODE* Simplify(DAG &G, const string& nodesym, LIST<NODE*> *predList);



void StandardReuseRewrite();


#endif
