#ifndef __NODE_H__
#define __NODE_H__


#include "Structs/interval.h"
#include "Structs/LIST.h"
#include "Structs/VECTOR.h"

#include "DAG/SpecialFunctions.h"

class NODE{
 
private:	NODE *nodeptr;   
public:		NODE* NodePtr() { return nodeptr; }  	  
public: 	interval range;
	  
protected:
   
  		//sym               *ns;    
  		string			ns;      
		LIST<NODE*>        *pred; 
	        LIST<NODE*>        *succ;
public:		unsigned int        num; 
		     

	   
			     
		     
public:
			    
		NODE();
		NODE(const string &id); 
	       ~NODE(); 
		
		
		NODE(NODE &n); // 2009June9
		
		friend string& Symbol(NODE *n){ return n->ns; }  
	
		friend int Number(NODE *n){ return n->num; }
			
		void setPred         (LIST<NODE*> *predList){ pred = predList; }
            	void InsertSuccessor (NODE *n){ succ->push(n); }  
 
           
		LIST<NODE*>* Pred ();  
            	NODE*        pred1();
            	NODE*        pred2();
            	LIST<NODE*>* Succ();
			
		
		virtual bool FP   (VECTOR<interval> &V);   
            	virtual void FPIO (VECTOR<interval> &V);
		virtual bool BP   (VECTOR<interval> &V);
		virtual void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                virtual void cFPD (VECTOR<NODE> &D);   
		virtual void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);  
            	virtual void cBPD (VECTOR<NODE> &D);
                        
                         
                   






			NODE& operator=(const NODE& n){nodeptr = n.nodeptr; return *this;}
			
			NODE&  operator+   (const NODE &b)const;
		 friend NODE&  operator+   (const double &s, const NODE &a);   
			NODE&  operator+   (const double &s)const;
		 friend NODE&  operator+   (const interval &s, const NODE &a);   
			NODE&  operator+   (const interval &s)const;
		
			NODE&  operator+   ()const;

			NODE&  operator-   (const NODE &b)const;
		 friend NODE&  operator-   (const double &s, const NODE &a);   
			NODE&  operator-   (const double &s)const;
		 friend NODE&  operator-   (const interval &s, const NODE &a);   
			NODE&  operator-   (const interval &s)const;
		
			NODE&  operator-   ()const;
			
			NODE&  operator*   (const NODE &b)const;
	         friend NODE&  operator*   (const double &s, const NODE &a);   
			NODE&  operator*   (const double &s)const;
		 friend NODE&  operator*   (const interval &s, const NODE &a);   
			NODE&  operator*   (const interval &s)const;
		
			NODE&  operator/   (const NODE &b)const;
		 friend NODE&  operator/   (const double &s, const NODE &a);   
			NODE&  operator/   (const double &s)const;
		 friend NODE&  operator/   (const interval &s, const NODE &a);   
			NODE&  operator/   (const interval &s)const;
			
			NODE&  operator^   (const NODE &b)const;
		 friend NODE&  operator^   (const double &s, const NODE &a);   
			NODE&  operator^   (const double &s)const;
		 friend NODE&  operator^   (const interval &s, const NODE &a);   
			NODE&  operator^   (const interval &s)const;
			
			
			
			void   operator+=   (const NODE &b);
		 //friend NODE&  operator+=   (const double &s, const NODE &a);
		 	void   operator+=   (const double &s);
			void   operator-=   (const NODE &b);
		 //friend NODE&  operator-=   (const double &s, const NODE &a); 
			void   operator-=   (const double &s);
			void   operator*=   (const NODE &b);
			void   operator*=   (const double &s);
			
			
			NODE& operator& (const NODE &b)const;
			//void operator&= (const NODE &b);
			//ToDo
			
			
			
		
		 friend NODE&   exp        (const NODE &b);
		 friend NODE&   log        (const NODE &b);
 
			

		 friend ostream & operator<<(ostream & stream, const NODE &n);


 };

 //a special function
//Friday22May2009
class NODE_SF_OEDmodel2s:public NODE{

 public:
                     NODE_SF_OEDmodel2s():NODE(){};
                     NODE_SF_OEDmodel2s(const string &symbol):NODE(symbol){}  
                     NODE_SF_OEDmodel2s(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
		    
};


class NODE_leq:public NODE{

 public:
                     NODE_leq():NODE(){};
                     NODE_leq(const string &symbol):NODE(symbol){}  
                     NODE_leq(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
                     
              
                     
};



class NODE_in:public NODE{

 public:
                     NODE_in():NODE(){};
                     NODE_in(const string &symbol):NODE(symbol){}  
                     NODE_in(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
                     
              
                     
};

class NODE_sum:public NODE{

 public:
                     NODE_sum():NODE(){};
                     NODE_sum(const string &symbol):NODE(symbol){}  
                     NODE_sum(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
		    
};
class NODE_prod:public NODE{

 public:
                     NODE_prod():NODE(){};
                     NODE_prod(const string &symbol):NODE(symbol){}  
                     NODE_prod(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
		    
};

class NODE_equal:public NODE{

 public:
                     NODE_equal():NODE(){};
                     NODE_equal(const string &symbol):NODE(symbol){}  
                     NODE_equal(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
                     
              
                     
};
class NODE_intersect:public NODE{

 public:
                     NODE_intersect():NODE(){};
                     NODE_intersect(const string &symbol):NODE(symbol){}  
                     NODE_intersect(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
		    
};

class NODE_con:public NODE{

 public:
                     NODE_con():NODE(){};
                     NODE_con(const string &symbol):NODE(symbol){}  
                     NODE_con(const string &symbol, interval &value):NODE(symbol){range = value;}  
		     
                     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
		    
};
class NODE_var:public NODE{
 public:
                     NODE_var(const string &symbol):NODE(symbol){}
                     NODE_var():NODE(){}
   
		     bool FP   (VECTOR<interval> &V);
                     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
		     void cBPD (VECTOR<NODE> &D);
};
class NODE_add:public NODE{
 public:
                     NODE_add(const string &symbol):NODE(symbol){}
                     NODE_add():NODE(){}  
  
		     bool FP    (VECTOR<interval> &V);
                     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D);
		     void cBPD  (VECTOR<NODE> &D);
                   
	        
};
class NODE_sub:public NODE{
 public:
                     NODE_sub(const string &symbol):NODE(symbol){}
                     NODE_sub():NODE(){}

		     bool FP   (VECTOR<interval> &V);
		     void FPIO (VECTOR<interval> &V);
		     bool BP   (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD (VECTOR<NODE> &D);
		     
	
};
class NODE_usub:public NODE{                                   //2008-03-24
 public:
                     NODE_usub(const string &symbol):NODE(symbol){}
                     NODE_usub():NODE(){}

		     bool FP    (VECTOR<interval> &V);
		     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cBPD  (VECTOR<NODE> &D);
		     
	
};
class NODE_mul:public NODE{
 public:
                     NODE_mul(const string &symbol):NODE(symbol){}
                     NODE_mul():NODE(){} 
  		     
                     bool FP    (VECTOR<interval> &V);
		     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D);
		     void cBPD  (VECTOR<NODE> &D);
		     
	
};
class NODE_div:public NODE{
 public:
                     NODE_div(const string &symbol):NODE(symbol){}
                     NODE_div():NODE(){} 
	    	     
                     bool FP    (VECTOR<interval> &V);
		     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D); 
		     void cBPD  (VECTOR<NODE> &D);
		     
		     
};


class NODE_power:public NODE{
 public:
                     NODE_power(const string &symbol):NODE(symbol){}
                     NODE_power():NODE(){} 
	    	     
                     bool FP    (VECTOR<interval> &V);
		     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D); 
		     void cBPD  (VECTOR<NODE> &D);
		     
		     
};


class NODE_exp:public NODE{ 
 public:
                     NODE_exp(const string &symbol):NODE(symbol){}
                     NODE_exp():NODE(){} 
  
		     bool  FP   (VECTOR<interval> &V);
		     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D);
		     void cBPD  (VECTOR<NODE> &D);
};

class NODE_log:public NODE{ 
 public:
                     NODE_log(const string &symbol):NODE(symbol){}
                     NODE_log():NODE(){} 
  
		     bool  FP   (VECTOR<interval> &V);
		     void FPIO  (VECTOR<interval> &V);
		     bool BP    (VECTOR<interval> &V);
		     void FPD  (VECTOR<interval> &V, VECTOR<interval> &D);
                     void cFPD (VECTOR<NODE> &D);
		     void BPD   (VECTOR<interval> &V, VECTOR<interval> &D);
		     void cBPD  (VECTOR<NODE> &D);
};









class vNODE{

private:
         NODE  *vec;
         int     size;

public:
vNODE();
vNODE(const vNODE &x);   
vNODE(int dim, char *name);
vNODE(int dim);
~vNODE(); 

vNODE& operator=(vNODE &x);   
NODE& operator()(int index);
const NODE& operator()(int index)const; 
int Size()const{ return size; };
friend ostream & operator<<(ostream& stream, const vNODE &V);
 
};

#endif





