#ifndef _ParameterReader_h__
#define _ParameterReader_h_

#include <string>
#include <sstream>
#include <map>
#include <iostream>
#include <fstream>
#include <vector>
#include "interval.h"



class fourIntegers{
public:
int  group_a;	
int variable_a;
int group_b;
int variable_b;
};
void getval(istream & stream, int &val)
{
string s;
while(stream.peek()==' '&& stream.good()) stream.get();
while(stream.peek()!=' '&&stream.good()) s += stream.get();
stringstream ss(s);
ss>>val;
}
istream & operator>>(istream &stream, fourIntegers &f){
getval(stream,f.group_a);
getval(stream,f.variable_a);
getval(stream,f.group_b);
getval(stream,f.variable_b);
return stream; 
}
ostream& operator<<(ostream &stream, const fourIntegers &f){
stream << f.group_a<<" "<<f.variable_a<< " "<<f.group_b<<" "<<f.variable_b;
return stream;
}






class ParameterReader{


public:
typedef std::string Key;
typedef std::string Value;
typedef std::map<Key,Value> HashTable;
typedef HashTable::iterator iterator;

private:
HashTable table;

public:
////////////////////////////////////////////////////////////////////////
//clear,find,insert,readFile,changeParameterValue
////////////////////////////////////////////////////////////////////////



void clear()
{ 
	table.clear();
}




Value find(Key a_key)
{

////////////////////////////////////////////////////////////////////////  
//	Find a key and return a value
//	If there is no such key then an EMPTY string 
//	is returned.
////////////////////////////////////////////////////////////////////////  

iterator it = table.find(a_key);
if(it!=table.end())	return it->second;
else						return "";
}

void insert(Key a_key, Value a_value)
{
//	Insert a new value.
    table[a_key] = a_value;
}


void readFile(const std::string &fileName)
{
    
std::ifstream in(fileName.c_str());
if (!in)
{
		cout<<"ERROR, Cannot access\n"<<fileName<<"\n";
		exit(1);
}
	
std::string line;
while( in.good() )
{
     
	std::getline(in,line);
	if(line.empty()) continue;
	if(line[0] != '#')
	{
        
        std::stringstream ss(line);
        Key key;
        Value value;
        //ss >> key;
        //ss >> value;
        ss>>key;
        std::string add;
        while(1)
        {
        	ss	>>	add; 
        	value	+=	add; 
			if( !ss.good() ){break;}; 
			value+=" ";
		}
        //cout<<"\nvalue="<<value;
        //cout<<"\nss.str() ="<<ss.str();    
        insert(key,value);
      }  
 }
in.close();

}



static void changeParameterValue(const std::string &fileName, 
 														std::string a_key, 
 														std::string a_value)
{
   
std::ifstream in;								
in.open(fileName.c_str());
std::vector<std::string> lines;
    
std::string line;
while( in.good() ){
	
	std::getline(in, line); 
     if (line[0] != '#'){
      		
      		std::stringstream ss(line);
        	Key key, value;
        	ss >> key;
        	ss >> value;
        	
        	if(key==a_key){
       				//create a new line with the new value 
           			std::string newline = key + " " + a_value;
           			lines.push_back(newline);
       	
        	}
        	else
           	lines.push_back(line);
      }
 	else
	lines.push_back(line);
}

in.close();

ofstream o(fileName.c_str());
for(int i=0; i<lines.size(); ++i) o << lines[i]  + "\n";	
o.close();	  
    


}

 
};



template<class Scalar>
Scalar parseString(const std::string& a_string)
{
	std::istringstream input(a_string);
	Scalar result;
	input >> result;
	return result;
}

#endif


