#ifndef __SORT_H__
#define __SORT_H__



// MergeSort-----------------------------------------------------------------------------


LIST<int> Merge(LIST<int> S1, LIST<int> S2 ){
  
  //***********************************************
  // Merge two nondecreasing sequences S1 and S2 to
  //***********************************************
  

  LIST<int> S;
  S1.MoveTop();
  S2.MoveTop();
  while( !S1.eol() && !S2.eol() ){
    if ( S1.Data()< S2.Data() ){ S.Insert(S1.Data()); S1.MoveDown(); S.MoveDown(); }
    else                       { S.Insert(S2.Data()); S2.MoveDown(); S.MoveDown(); }
  }
  while( !S1.eol() ){ S.Insert(S1.Data()); S1.MoveDown(); S.MoveDown(); }
  while( !S2.eol() ){ S.Insert(S2.Data()); S2.MoveDown(); S.MoveDown(); }

  return S;
  
}



LIST<int> MergeSort(LIST<int> S){

  int n = S.Size();

  
  if (n>1){
    
   LIST<int> S1, S2;
   S.Partition(S1,S2, (int)floor(n/2.0) );  //Linux
   return Merge(MergeSort(S1), MergeSort(S2));
   }
  else { return S; }
  
}

//-----------------------------------------------------------------------------------



//QuickSort ------------------------------------------------------------------


void swap(double * a, int i, int j){

  double tmp = a[i];
  a[i] = a[j];
  a[j] = tmp;
}

int Partition(double * a, int p, int r){
  
  double x = a[p]; //pivot
  int i = p-1;
  int j = r+1;
  while (i<j){
         do {j--;} while( a[j] > x );
         do {i++;} while( a[i] < x );
         if (i<j) { swap(a,i,j); }
         else return j;
  }
}

void QuickSort(double * a, int p, int r){

  if(p<r){
    int q = Partition(a,p,r);
    QuickSort(a,p,q);
    QuickSort(a,q+1,r);
    
  }
}


//-----------------------------------------------------------------------------------



template<class T>
class SORT{

private:
struct element{
  int l;
  T data;       
};


 

public:
static void SelSort(VECTOR<T> &y, VECTOR< element > &x, int i);
static void SelectionSort(VECTOR<T> &OUT, VECTOR<int> &rank, VECTOR<T> &NTP);

};


template<class T>
void SORT<T>::SelSort(VECTOR<T> &y, VECTOR< element > &x, int i){
   
  // Selection sort
  // Find smallest entry in x(1:n) and swap it with the first entry.
  // Find smallest entry in x(2:n) and swap it with the second entry.
  // ...
  // Call: SelSort(x,1)


  

  if (i == x.Size()){ 
    for(int i=1; i<=x.Size(); i++){ y(i)= x(i).data;  } 
    }
  else              {
                       // Find smallest and swap 
                       //--------------------------------
                       int s = 999999999;  int ind; 
                       element e;  
                       for (int k=i; k<=x.Size(); k++){
			 
                            if ( x(k).l < s ){ s = x(k).l; ind = k;}
			   
		       }
                       
                       e = x(i); x(i) = x(ind); x(ind) = e;
                       
		       //----------------------------  
		       SelSort(y,x,i+1);
  }
}


template<class T>
void SORT<T>::SelectionSort( VECTOR<T> &OUT, VECTOR<int> &rank, VECTOR<T> &NTP){



  // SORTS THE COMPONENTS OF NTP IN INCREASING ORDER OF THEIR rank
  // OUT(1) = LOWEST ranked COMPONENT
  //...
  // OUT(N) = HIGHEST ranked COMPONENT 
  

  VECTOR< element > S(rank.Size());
  for(int i=1; i<=rank.Size(); i++){     
    S(i).l    =   rank(i); 
    S(i).data =   NTP(i);
  }
  SelSort(OUT,S,1);
}
#endif

