#ifndef __VECTOR_H__
#define __VECTOR_H__


#include<stdio.h>
#include<iostream>
#include<stdlib.h>
using namespace std;




template<class T>
class VECTOR{

private:

T    *vec;
int  size;

 
public: 

VECTOR();       
VECTOR(int dimension);
VECTOR(int dimension, const T &value);
VECTOR(const VECTOR & x);                 
~VECTOR();

 
int             Size()const{ return(size); };
T&              operator()(int index);
const T&        operator()(int index)const;
T&              operator[](int index);
const T&        operator[](int index)const;
VECTOR&         operator = (const VECTOR& x);
bool            operator==(const VECTOR& V)const;
//friend  ostream& operator<<(ostream & stream, const VECTOR& V);

template<class U> friend ostream & operator<<(ostream & stream, const VECTOR<U>& V);
};


template<class T>
VECTOR<T>::VECTOR(){vec=0; size=0;}

template<class T>
VECTOR<T>::VECTOR(int dimension){
    vec = new T[dimension];                        
    size = dimension;
}
template<class T>
VECTOR<T>::VECTOR(int dimension, const T &value){
    vec = new T[dimension];                        
    size = dimension;
    for(int i=0; i<size; i++){vec[i]=value;}
}

template<class T>
VECTOR<T>::VECTOR(const VECTOR<T> & x){

    // COPY constructor

    size = x.size;
    if (x.vec == 0){ vec = 0;}                                  
    else {  vec = new T[size]; 
            for (int i=0; i<size; i++){ vec[i] = x.vec[i]; }
    }
 }

template<class T>
VECTOR<T>::~VECTOR(){

  if (vec != 0){ delete [] vec; vec = 0; size = 0;}
}

template<class T>
T& VECTOR<T>::operator()(int index){                //non-constant

  // index range 1,..., size
  
   if (index<1 || index>size ){ cout << "\n\n\nINDEX NOT IN RANGE, T& VECTOR<T>::operator()(int index)"; exit(1);}
   return vec[index-1];
}

template<class T>
const T& VECTOR<T>::operator()(int index)const{     //constant

  // index range 1...,size
  
  if (index<1 || index>size ){ cout << "\n\n\nINDEX NOT IN INDEX RANGE, const T& VECTOR<T>::operator()(int index)const"; exit(1);}
  return vec[index-1];
}


template<class T>
T& VECTOR<T>::operator[](int index){                //non-constant

  // index range 0,..., size-1
  
   if (index<0 || index>size-1 ){ cout << "\n\n\nINDEX NOT IN RANGE, T& VECTOR<T>::operator[](int index)"; exit(1);}
   return vec[index];
}

template<class T>
const T& VECTOR<T>::operator[](int index)const{     //constant

  // index range 0...,size-1
  
  if (index<0 || index>size-1 ){ cout << "\n\n\nINDEX NOT IN INDEX RANGE, const T& VECTOR<T>::operator[](int index)const"; exit(1);}
  return vec[index];
}





template<class T>
VECTOR<T>& VECTOR<T>::operator=(const VECTOR<T>& x){

  if (this == &x) return (*this);

  size = x.size;
  if ( vec != 0 ){ delete [] vec; }
  if ( x.vec != 0 ){
                 vec = new T[size];
                 for (int i=0; i<size; i++){ vec[i] = x.vec[i];}
		 }
  else {vec = 0;}

  return (*this);
}

template<class T>
bool VECTOR<T>::operator==(const VECTOR<T> & V)const{
  if (!(size ==V.size)) return 0;
  
  for(int i=0; i<size; i++){
      if( !(vec[i]==V[i]) ){ return 0;}
  }
  return 1;
}



//-------------------------------------------------------------

template<class U> ostream & operator<<(ostream & stream, const VECTOR<U>& V){

	stream<<V.vec[0];  
	for(int i=1; i<V.size; i++){
		stream<<"\n"<<V.vec[i];
	}
	return stream;       
}

//-------------------------------------------------------------








#endif

