/*   File: round.h

     A header file that defines the directed  
     rounding modes for Linux and Sparc.

     Author: Warwick Tucker <warwick@math.uu.se>
     Latest edit: Wed Oct 15, 2001
*/


#ifndef __ROUND_H__
#define __ROUND_H__



#if defined(__linux)
#include <fenv.h>                     
#define ROUND_DOWN  FE_DOWNWARD
#define ROUND_UP    FE_UPWARD
#define ROUND_NEAR  FE_TONEAREST
#define ROUND_ZERO  FE_TOWARDZERO
#define setRound    fesetround
#endif

#if defined(__sparc)
#include <ieeefp.h>
#define ROUND_DOWN  FP_RM
#define ROUND_UP    FP_RP
#define ROUND_NEAR  FP_RN
#define ROUND_ZERO  FP_RZ
#define setRound    fpsetround
#endif


#endif
