

	
		


void ConstructDerivativeByForwardSweep(DAG &G, NODE *n, NODE *x, VECTOR<NODE> &D, VECTOR<NODE*> &PATH){
 
  
  /*
  	dndx by forward walk
  */
  
  NODE& ZERO = MakeConstant(G, interval(0.0), "0");
  NODE& ONE  = MakeConstant(G, interval(1.0), "1"); 
 
  for(int i=1; i<=D.Size(); i++){ D(i) = ZERO; }
  
  D( x->NodePtr()->num ) = ONE;
     
  for(int i = 1; i<=PATH.Size(); i++){  PATH(i)->cFPD(D);  }

}





void ConstructDerivative(DAG &G, NODE *n, VECTOR<NODE> &D, VECTOR<NODE*> &PATH){
 
  /*
  	dndx by backward walk
  */
  
  
  NODE& ZERO = MakeConstant(G, interval(0), "0");
  NODE& ONE  = MakeConstant(G, interval(1), "1"); 
 
  for(int i=1; i<=D.Size(); i++){ D(i) = ZERO; }
  
  D( n->NodePtr()->num ) = ONE;
     
  for(int i = 1; i<=PATH.Size(); i++){  PATH(i)->cBPD(D);  }

}







void ConstructDerivative(VECTOR<NODE*> &df, 
			 DAG &G, 
			 NODE *f, 
			 const VECTOR<NODE*> &x
			 )
			 
{






NODE& ZERO = MakeConstant(G, interval(0.0), "0");
NODE& ONE  = MakeConstant(G, interval(1.0), "1"); 
 
 
 NODE *n = f->NodePtr();
 
 for(int i=1; i<=x.Size(); i++){
 

	VECTOR<NODE>  D(G.Size());
	for(int j=1; j<=D.Size(); j++){ D(j) = ZERO; }
	D( n->num ) = ONE;
 
	VECTOR<NODE*> PATH = Path(G,n); 

	for(int j = 1; j<=PATH.Size(); j++){  PATH(j) -> cBPD(D);  }

	n = D(x(i)->num).NodePtr();
	df(i) = n;
 
 }

}




void BPD(const VECTOR<NODE*> &BACKWARD, VECTOR<interval> &V, VECTOR<interval> &D){
  
  	/*
  	Backward Computation Derivative  	
  	*/
  	
	for (int i=1; i<=D.Size();i++){ D(i) = interval(0.0); }
 	D( BACKWARD(1)->num ) = interval(1);
    
  	for(int i = 1; i<=BACKWARD.Size(); i++){
    		BACKWARD(i)->BPD(V,D);
  	}

}


void cBPD(const VECTOR<NODE*> &BACKWARD, VECTOR<NODE> &D){
   
  	for(int i = 1; i<=D.Size(); i++){
    		BACKWARD(i)->cBPD(D);
  	}
}










