#include "DAG/GraphViz.h"



void DefineNodeStyle(NODE *n, ostream &o){
		
		
		o<<endl<<n->num;
		if(isConstant(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightcyan1,fontsize=7, label=\""<<Symbol(  n )<<"\"];";		
		}
		else if(isSource(n)){
		o<<" [style=filled, width=0.05, height =0.05, shape = box, color=orange1,label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isEquality(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightpink1,label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isLessOrEqual(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=gold,label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isInclusion(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightpink1,label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isAdd(n)||isSub(n)){
		o<<" [color=palegoldenrod, width=0.05, height =0.05, shape = box,style=filled, label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isUSub(n)){
		o<<" [color=lightyellow, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isMul(n)||isDiv(n)){
		o<<" [color=lightskyblue1, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isExp(n)||isLog(n)){
		o<<" [color=palegreen, width=0.05, height =0.05, shape=box, style=filled,label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(isPow(n)){
		o<<" [color=lightseagreen, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  n  )<<"\"];";
		}
		else if(Symbol(n)=="SF_OEDmodel2s"){
		o<<" [color=white, width=0.05, height =0.05, shape=box, style=filled, label=\""<<"s"<<"\"];";
		}
		else{
		o<<" [label=\""<<Symbol(  n  )<<"\"];";
		}
    		
}

void DefineNodeStyle(NODE *n, interval range, ostream &o){
		
		
		o<<endl<<n->num;
		
		if(isEmpty(range)){ 
		o<<" [shape=tripleoctagon, size = 20, style=filled, color=red4,fontsize=20, label=\""<<Symbol(n)+ToString(range)<<"\"];";}
		
		else if(isConstant(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightcyan1,fontsize=7, label=\""<<Symbol(n)+ToString(range)<<"\"];";		
		}
		else if(isSource(n)){
		o<<" [style=filled, width=0.05, height =0.05, shape = box, color=orange1,label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isEquality(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightpink1,label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isLessOrEqual(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=gold,label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isInclusion(n)){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightpink1,label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isAdd(n)||isSub(n)){
		o<<" [color=palegoldenrod, width=0.05, height =0.05, shape = box,style=filled, label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isUSub(n)){
		o<<" [color=lightyellow, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isMul(n)||isDiv(n)){
		o<<" [color=lightskyblue1, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isExp(n)||isLog(n)){
		o<<" [color=palegreen, width=0.05, height =0.05, shape=box, style=filled,label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		else if(isPow(n)){
		o<<" [color=lightseagreen, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  n  )+ToString(range)<<"\"];";
		}
		
		else if(Symbol(n)=="SF_OEDmodel2s"){
		o<<" [color=white, width=0.05, height =0.05, shape=box, style=filled, label=\""<<"s"<<"\"];";
		}
		else{
		o<<" [label=\""<<Symbol(  n  )<<"\"];";
		}
    		
}


void DefineNodeStyles(DAG &G, ostream &o){


	LIST<NODE*> *L = G.nodelist;
	L->MoveTop();
	while ( !L->eol() ){
		o<<endl<<L->Data()->num;
		if(isConstant(L->Data())){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightcyan1,fontsize=7, label=\""<<Symbol(  L->Data()  )<<"\"];";		
		}
		else if(isSource(L->Data())){
		o<<" [style=filled, width=0.05, height =0.05, shape = box, color=orange1,label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isEquality(L->Data())){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightpink1,label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isLessOrEqual(L->Data())){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=gold,label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isInclusion(L->Data())){
		o<<" [width=0.05, height =0.05, shape=box, style=filled, color=lightpink1,label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isAdd(L->Data())||isSub(L->Data())){
		o<<" [color=palegoldenrod, width=0.05, height =0.05, shape = box,style=filled, label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isUSub(L->Data())){
		o<<" [color=lightyellow, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isMul(L->Data())||isDiv(L->Data())){
		o<<" [color=lightskyblue1, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isExp(L->Data())||isLog(L->Data())){
		o<<" [color=palegreen, width=0.05, height =0.05, shape=box, style=filled,label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(isPow(L->Data())){
		o<<" [color=lightseagreen, width=0.05, height =0.05, shape=box, style=filled, label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
		else if(Symbol(L->Data())=="SF_OEDmodel2s"){
		o<<" [color=white, width=0.05, height =0.05, shape=box, style=filled, label=\""<<"s"<<"\"];";
		}
		else{
		o<<" [label=\""<<Symbol(  L->Data()  )<<"\"];";
		}
    		L->MoveDown();
  	}
}



void DefineSubGraph(int i, LIST<NODE*> *L, ostream &o){
 
		o<<"\nsubgraph cluster"+ToString(i)+"{";
		
		L->MoveTop();
		while ( !L->eol() ){
			DefineNodeStyle(L->Data(), o);
			L->MoveDown();
  		}

		o<<"\nstyle=filled\ncolor=lightgrey";
		o<<"\n}";
}	

void Writedot(DAG &G, ostream &o, LIST< LIST<NODE*>* > *s){
 
 // Requires that the nodes enumerated 1,2,3,....
 G.NodeEnumeration();
 
 
	o<<"digraph{";
	o<<"\nbgcolor=dimgray\n";
	o<<"\nrankdir=BT;";
	
	s->MoveTop();
	int i(0);
	while(!s->eol()){
		i++;
		DefineSubGraph(i,s->Data(),o);
		s->MoveDown();
	}
	
	DefineNodeStyles(G,o);
	o<<"\nedge [arrowsize=0.5]\n";
	
	
	
	VECTOR<int> LEVEL(G.Size());
	ComputeSuccLevels(G, LEVEL);
	VECTOR<NODE*> FORWARD(G.Size());
	ForwardByLevel(G, FORWARD, LEVEL);

	LIST<NODE*> *p;
	for(int i=1; i<=FORWARD.Size();i++){

		
		p = FORWARD(i)->Pred();
		p->MoveTop();
		
		if(isBinaryOp(FORWARD(i)) && !isCommutative(FORWARD(i))){
		
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
			p->MoveDown();
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
		
		}
		else if(isInclusion(FORWARD(i))){
			
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
			p->MoveDown();
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
				p->MoveDown();
			}
		}
		else{
			
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":s;";	
				p->MoveDown();
			}
		}
	}

	
	
	
	
o<<"\n}"; 
}


dotInput::dotInput():bgcolor("dimgray"),
				nodesep("0.1"), 
				label(""), 
				rankdir("BT"),
				edgestyle(""),
				arrowsize("0.5"){}



void writedot(DAG &G, const string &filename, dotInput *input){
	ofstream o(filename.c_str());
	
	// Requires that the nodes enumerated 1,2,3,....

	G.NodeEnumeration();
if(input)
{ 
	o<<"digraph{";
	o<<"\nbgcolor="<<input->bgcolor;
	o<<"\nnodesep="<<input->nodesep;
	o<<"\nlabel=\""<<input->label<<"\"\n";
	o<<"\nrankdir="<<input->rankdir;
	DefineNodeStyles(G,o);
	o<<"\nedge [arrowsize="+input->arrowsize+"]\n";
 }
 else
 {
    o<<"digraph{";
	//o<<"\nbgcolor=dimgray\n";
	o<<"\nbgcolor=azure3\n";
	o<<"\nnodesep=0.1\n";
	o<<"\nrankdir=BT;";
	DefineNodeStyles(G,o);
	o<<"\nedge [arrowsize=0.5]\n";
}	
 
	
		


	
	
	VECTOR<int> LEVEL(G.Size());
	ComputeSuccLevels(G, LEVEL);
	VECTOR<NODE*> FORWARD(G.Size());
	ForwardByLevel(G, FORWARD, LEVEL);

	LIST<NODE*> *p;
	for(int i=1; i<=FORWARD.Size();i++){

		
		p = FORWARD(i)->Pred();
		p->MoveTop();
		
		if(isBinaryOp(FORWARD(i)) && !isCommutative(FORWARD(i))){
		
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
			p->MoveDown();
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
		
		}
		else if(isInclusion(FORWARD(i))){
			

			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
			p->MoveDown();
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
				p->MoveDown();
			}
		}
		else{
			
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":s;";	
				p->MoveDown();
			}
		}
	}

	
	
	
	
o<<"\n}"; 




}


void writedot(Filter &F, const string &filename, dotInput *input){
 
 
	
	ofstream o(filename.c_str());
	
	// Requires that the nodes enumerated 1,2,3,....

	F.G->NodeEnumeration();
if(input)
{ 
	o<<"digraph{";
	o<<"\nbgcolor="<<input->bgcolor;
	o<<"\nnodesep="<<input->nodesep;
	o<<"\nlabel=\""<<input->label<<"\"\n";
	o<<"\nrankdir="<<input->rankdir;
	//o<<"\nedge [style=dotted, arrowhead=none]\n";
	o<<"\nedge [arrowsize="+input->arrowsize+"]\n";
 }
 else
 {
    o<<"digraph{";
	o<<"\nbgcolor=dimgray\n";
	//o<<"\nbgcolor=azure3\n";
	o<<"\nnodesep=0.1\n";
	o<<"\nrankdir=BT;";
	o<<"\nedge [arrowsize=0.5]\n";
}	
 
	
	
	//All nodes
	LIST<NODE*> *L;
	F.G->GetNodeList(L);
	L->MoveTop();
	while ( !L->eol() ){
		o<<endl<<L->Data()->num;
		DefineNodeStyle(L->Data(),F.V(L->Data()->num),o);

		
    		F.G->nodelist->MoveDown();
  	}
	
	

	
	VECTOR<int> LEVEL(F.G->Size());
	ComputeSuccLevels(*F.G, LEVEL);
	VECTOR<NODE*> FORWARD(F.G->Size());
	ForwardByLevel(*F.G, FORWARD, LEVEL);

	LIST<NODE*> *p;
	for(int i=1; i<=FORWARD.Size();i++){

		
		p = FORWARD(i)->Pred();
		p->MoveTop();
		
		if(isBinaryOp(FORWARD(i)) && !isCommutative(FORWARD(i))){
		
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
			p->MoveDown();
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
		
		}
		else if(isInclusion(FORWARD(i))){
			
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
			p->MoveDown();
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
				p->MoveDown();
			}
		}
		else{
			
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":s;";	
				p->MoveDown();
			}
		}
	}

	
	
	
	
	
	
	
o<<"\n}"; 
}





void Writedot(DAG &G, ostream &o, const string &Label){

 // Requires that the nodes enumerated 1,2,3,....

G.NodeEnumeration();
 
	o<<"digraph{";
	o<<"\nbgcolor=azure3\n";
	o<<"\nnodesep=0.1\n";
	o<<"\nlabel=\""<<Label<<"\"\n";
	o<<"\nrankdir=BT;";
	DefineNodeStyles(G,o);
	o<<"\nedge [arrowsize=0.5]\n";
	
	
	
	
	VECTOR<int> LEVEL(G.Size());
	ComputeSuccLevels(G, LEVEL);
	VECTOR<NODE*> FORWARD(G.Size());
	ForwardByLevel(G, FORWARD, LEVEL);

	LIST<NODE*> *p;
	for(int i=1; i<=FORWARD.Size();i++){

		
		p = FORWARD(i)->Pred();
		p->MoveTop();
		
		if(isBinaryOp(FORWARD(i)) && !isCommutative(FORWARD(i))){
		
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
			p->MoveDown();
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
		
		}
		else if(isInclusion(FORWARD(i))){
			

			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
			p->MoveDown();
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
				p->MoveDown();
			}
		}
		else{
			
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":s;";	
				p->MoveDown();
			}
		}
	}

	
	
	
	
o<<"\n}"; 
}





void Writedot(Filter &F, ostream &o){
 
 // Requires that the nodes enumerated 1,2,3,....
 F.G->NodeEnumeration();
 

	o<<"digraph{";
	o<<"\nrankdir=BT;";
	o<<"\nnodesep=0.1\n";
	o<<"\nbgcolor=dimgray\n";
	o<<"\nedge [arrowsize=0.5]\n";
	
	//All nodes
	LIST<NODE*> *L;
	F.G->GetNodeList(L);
	L->MoveTop();
	while ( !L->eol() ){
		o<<endl<<L->Data()->num;
		DefineNodeStyle(L->Data(),F.V(L->Data()->num),o);

		
    		F.G->nodelist->MoveDown();
  	}
	
	
	
	
	VECTOR<int> LEVEL(F.G->Size());
	ComputeSuccLevels(*F.G, LEVEL);
	VECTOR<NODE*> FORWARD(F.G->Size());
	ForwardByLevel(*F.G, FORWARD, LEVEL);

	LIST<NODE*> *p;
	for(int i=1; i<=FORWARD.Size();i++){

		
		p = FORWARD(i)->Pred();
		p->MoveTop();
		
		if(isBinaryOp(FORWARD(i)) && !isCommutative(FORWARD(i))){
		
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
			p->MoveDown();
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
		
		}
		else if(isInclusion(FORWARD(i))){
			
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
			p->MoveDown();
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
				p->MoveDown();
			}
		}
		else{
			
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":s;";	
				p->MoveDown();
			}
		}
	}

	
	
	
	
	
	
	
o<<"\n}"; 
}






void WritedotSIS(Filter &F, ostream &o){
 
 // Source Intermediate Sink grouping
 
 // Requires that the nodes enumerated 1,2,3,....
 // If unsure, call G.NodeEnumeration() before calling Writedot.
 
o<<"digraph{";

	o<<"\nrankdir=BT;";
	
	LIST<NODE*> *L;
	LIST<NODE*> SourceList,IntermediateList,SinkList;
	GetSISNodes(*F.G,SourceList,IntermediateList,SinkList);
	
	o<<"\nsubgraph cluster0{";
		
		//All Source Nodes
	
		SourceList.MoveTop();
		while ( !SourceList.eol() ){
		
			o<<endl<<SourceList.Data()->num;
			o<<" [label=\""<<Symbol(SourceList.Data())<<F.V(SourceList.Data()->num )<<"\"];"	;
    			SourceList.MoveDown();
    			
  		}

	o<<"\nstyle=filled\ncolor=lightgrey";
	o<<"\n}";
	
	
	o<<"\nsubgraph cluster1{";
		
		//All Intermediate Nodes
	
		IntermediateList.MoveTop();
		while ( !IntermediateList.eol() ){
		
			o<<endl<<IntermediateList.Data()->num;
			o<<" [label=\""<<Symbol(IntermediateList.Data())<<F.V(IntermediateList.Data()->num )<<"\"];"	;
    			IntermediateList.MoveDown();
    			
  		}
	o<<"\nstyle=filled\ncolor=lightgrey";
	o<<"\n}";
	
	
	o<<"\nsubgraph cluster2{";
		
		//All Sink Nodes
	
		SinkList.MoveTop();
		while ( !SinkList.eol() ){
		
			o<<endl<<SinkList.Data()->num;
			o<<" [label=\""<<Symbol(SinkList.Data())<<F.V(SinkList.Data()->num )<<"\"];"	;
    			SinkList.MoveDown();
    			
  		}
	o<<"\nstyle=filled\ncolor=lightgrey";
	o<<"\n}";
	
	VECTOR<int> LEVEL(F.G->Size());
	ComputeSuccLevels(*F.G, LEVEL);
	VECTOR<NODE*> FORWARD(F.G->Size());
	ForwardByLevel(*F.G, FORWARD, LEVEL);

	LIST<NODE*> *p;
	for(int i=1; i<=FORWARD.Size();i++){

		
		p = FORWARD(i)->Pred();
		p->MoveTop();
		
		if(isBinary(FORWARD(i)) && !isCommutative(FORWARD(i))){
		
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":sw;";
			p->MoveDown();
			o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":se;";
		
		}
		else{
			
			while(!p->eol()){
				o<<endl<<p->Data()->num<<":n->"<<FORWARD(i)->num<<":s;";	
				p->MoveDown();
			}
		}
	}

	
	
	
	
o<<"\n}"; 
}



