#include "DAG/SpecialFunctions.h"






////////////////////////////////////////////////////////////////////////
//OEDmodel2s = (exp(-p1t)-exp(p2t))/(p2-p1), 
//				if p1 neq p2, 
//			-texp(-pt), 
//				if p1=p2=p
////////////////////////////////////////////////////////////////////////

//
//	tstar_fcn
//
interval tstar_fcn(interval &p1, interval &p2)
{
if( !(p1 == p2) )	return ( log(p2) - log(p1) )/( p2 - p1);
else					return 1.0/p1;
}
//
//	s_fcn
//
interval s_fcn(interval t, interval p1, interval p2)
{
if( !(p1 == p2) )		return ( exp(-p2*t)-exp(-p1*t) )/ (p2-p1);
else 					return -t*exp(-p1*t);
}
//
//	s_fcn
//
interval SpecialFunction_OEDmodel2s(interval &T, interval &P1, interval &P2){

interval P1lo(inf(P1)), P1hi(sup(P1)), P2lo(inf(P2)), P2hi(sup(P2));
double lo,hi;
interval tstar;


//	lower bound

tstar = tstar_fcn(P1lo, P2lo); 
 
if( !isEmpty( tstar & T ) )	lo	=	inf( s_fcn(tstar ,P1lo, P2lo) ); 
else if (T<tstar) 			lo	=	inf( s_fcn(isup(T), P1lo, P2lo) );
else 							lo	=	inf( s_fcn(iinf(T), P1lo, P2lo) ); 

 
//	upper bound

tstar = tstar_fcn(P1hi, P2hi); 
 
if( !isEmpty( tstar & T ) ){
	double g;
	g	=	sup( s_fcn(iinf(T) ,P1hi, P2hi) );
	hi	=	sup( s_fcn(isup(T) ,P1hi, P2hi) );
	if(g>hi) hi=g;
}
else if (T<tstar) 	hi	=	sup( s_fcn(iinf(T), P1hi, P2hi) );
else 					hi	=	sup( s_fcn(isup(T), P1hi, P2hi) ); 

return interval(lo,hi);
}














