# simple plots similar to Fig. 1
@simpleplots =("action_1_1_model_1",
	       "action_1_1_model_2");

# Supplementary material
@supptables =("action_2_1_model_1_noisyData_alpha_00",
	      "action_2_1_model_1_prfctData_alpha_00",
	      "action_2_1_model_2_noisyData_alpha_00",
	      "action_2_1_model_2_prfctData_alpha_00");

# Figure 3
@fig3=("action_2_4_model_2_prfctData_alpha_00");

# Optimal design, model 1, color plots
@col =("action_3_1_model_1_noisyData_alpha_00_standErrFunc",
       "action_3_1_model_1_noisyData_alpha_15_standErrFunc",
       "action_3_1_model_1_noisyData_alpha_30_standErrFunc");

# Optimal design, model 1, problem 1,2 and 3
@t2upper =("action_3_2_model_1_noisyData_alpha_00_standErrFunc",
	   "action_3_2_model_1_noisyData_alpha_30_standErrFunc",
	   "action_3_6_model_1_noisyData_alpha_00_standErrFunc",
	   "action_3_6_model_1_noisyData_alpha_30_standErrFunc",
	   "action_3_7_model_1_noisyData_alpha_00_standErrFunc",
	   "action_3_7_model_1_noisyData_alpha_30_standErrFunc");

# Optimal design, model 1, problem 1-3, dose windows
@t2lower_dose =("action_3_2_model_1_noisyData_alpha_00_standErrFunc_doseWindow_1",
		"action_3_2_model_1_noisyData_alpha_00_standErrFunc_doseWindow_2",
		"action_3_6_model_1_noisyData_alpha_00_standErrFunc_doseWindow_1",
		"action_3_6_model_1_noisyData_alpha_00_standErrFunc_doseWindow_2",
		"action_3_7_model_1_noisyData_alpha_00_standErrFunc_doseWindow_1",
		"action_3_7_model_1_noisyData_alpha_00_standErrFunc_doseWindow_2");

# Optimal design, model 1, problem 1-3, time windows
@t2_lower_time =("action_3_2_model_1_noisyData_alpha_00_standErrFunc_timeWindow_1",
		 "action_3_2_model_1_noisyData_alpha_00_standErrFunc_timeWindow_2",
		 "action_3_6_model_1_noisyData_alpha_00_standErrFunc_timeWindow_1",
		 "action_3_6_model_1_noisyData_alpha_00_standErrFunc_timeWindow_2",
		 "action_3_7_model_1_noisyData_alpha_00_standErrFunc_timeWindow_1",
		 "action_3_7_model_1_noisyData_alpha_00_standErrFunc_timeWindow_2");

# Optimal design, model 2, problem 1-2
@od_model2 =( "action_3_1_model_2_noisyData_alpha_00_standErrFunc",
	      "action_3_1_model_2_noisyData_alpha_30_standErrFunc",
	      "action_3_2_model_2_noisyData_alpha_00_standErrFunc",
	      "action_3_2_model_2_noisyData_alpha_30_standErrFunc");

# Optimal design, model 2, problem 1 and 2, dose windows and time windows
@mod2_windows =("action_3_1_model_2_noisyData_alpha_00_standErrFunc_timeWindow1",
		"action_3_1_model_2_noisyData_alpha_00_standErrFunc_timeWindow2",
		"action_3_1_model_2_noisyData_alpha_00_standErrFunc_doseWindow1",
		"action_3_1_model_2_noisyData_alpha_00_standErrFunc_doseWindow2",
		"action_3_2_model_2_noisyData_alpha_00_standErrFunc_timeWindow1",
		"action_3_2_model_2_noisyData_alpha_00_standErrFunc_timeWindow2",
		"action_3_2_model_2_noisyData_alpha_00_standErrFunc_doseWindow1",
		"action_3_2_model_2_noisyData_alpha_00_standErrFunc_doseWindow2");

# Comparison to PopED in Table 4: Paraest of PopED optimal design, model 2 problem 1
@c1 =("action_2_8_model_2_noisyData_alpha_00");

# Comparison to PopED in Table 4: Paraest of our optimal design, model 2 problem 1
@c2 =("action_2_9_model_2_noisyData_alpha_00");

# Optimal design, model 2, underdetermined system
@mod2_underdet =("action_3_2_model_2_noisyData_alpha_00_standErrFunc_underDetermined");

@problems=@mod2_underdet;
$size=@problems;
print "Consider ".$size." problems\n";
$mydir1="PROBLEMS/";
$mydir2="SOLUTIONS/";
for ($ip=0;$ip<$size;$ip++){
    print "Consider problem ".$problems[$ip]."\n";
    system("./MyOptExpDes ".$mydir1.$problems[$ip]." > ".$mydir2.$problems[$ip]);
}
